import { defGetter } from "./getter.js";
/**
 * Unchecked version of {@link getIn}. Returns `undefined` if path is
 * invalid.
 *
 * @remarks
 * The type parameter `T` can be used to indicate the type of the nested
 * value to be retrieved (default: `any`).
 *
 * @example
 * ```ts
 * getInUnsafe({ a: { b: { c: 23 } } }, "a.b.c");
 * // 23
 * ```
 *
 * @param state -
 * @param path -
 */
export const getInUnsafe = (state, path) => defGetter(path)(state);
export function getIn(state, path) {
    return defGetter(path)(state);
}
