import { defMutator } from "./mutator.js";
/**
 * Unchecked version of {@link mutIn}.
 *
 * @remarks
 * The type parameter `T` can be used to indicate the type of the nested
 * value to be mutated (default: `any`).
 *
 * @example
 * ```ts
 * mutIn({ a: { b: [10, 20] } }, "a.b.1", 23);
 * // { a: { b: [ 10, 23 ] } }
 *
 * // fails (see `mutator` docs)
 * mutIn({}, "a.b.c", 23);
 * // undefined
 * ```
 *
 * @param state -
 * @param path -
 * @param val -
 */
export const mutInUnsafe = (state, path, val) => defMutator(path)(state, val);
export function mutIn(state, path, val) {
    return defMutator(path)(state, val);
}
